unit sortieren_U;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Init: TButton;
    Ausgabe_unsort: TButton;
    Edit1: TEdit;
    SelectionSort: TButton;
    InsertionSort: TButton;
    Bubblesort: TButton;
    Label3: TLabel;
    Edit2: TEdit;
    Alles_Loeschen: TButton;
    Schliessen: TButton;
    GroupBox1: TGroupBox;
    Edit3: TEdit;
    Edit5: TEdit;
    Feld_loeschen: TButton;
    Init1: TButton;
    Init2: TButton;
    GroupBox2: TGroupBox;
    Edit6: TEdit;
    Edit8: TEdit;
    Edit7: TEdit;
    procedure SchliessenClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure InitClick(Sender: TObject);
    procedure Alles_LoeschenClick(Sender: TObject);
    procedure Ausgabe_unsortClick(Sender: TObject);
    procedure SelectionSortClick(Sender: TObject);
    procedure Feld_loeschenClick(Sender: TObject);
    procedure Init1Click(Sender: TObject);
    procedure Init2Click(Sender: TObject);
    procedure InsertionSortClick(Sender: TObject);
    procedure BubblesortClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

type
  feld = array[1..10] of integer;

var
  Form1: TForm1;
  f_original,f_ausw,f_einfg,f_bubble: feld;

implementation

{$R *.DFM}

procedure TForm1.SchliessenClick(Sender: TObject);
begin
  Close;
end;

{----------- Zufallszahlengenrator aktivieren -------------}
procedure TForm1.FormCreate(Sender: TObject);
begin
  Randomize;
end;

{- initialisiert ein Feld von 10 zufaelligen ganzen Zahlen -}
procedure TForm1.InitClick(Sender: TObject);
var
  i: integer;
begin
  for i := 1 to 10 do f_original[i] := Random(100)+1;
end;

{------------------ Loescht alle Bildschirminhalte --------}
procedure TForm1.Alles_LoeschenClick(Sender: TObject);
begin
  Edit1.Clear;
  Edit2.Clear;
  Edit3.Clear;
  Edit5.Clear;
  Edit6.Clear;
  Edit7.Clear;
  Edit8.Clear;
end;

{--------- Loescht die Ausgabe des sortierten Feldes ------}
procedure TForm1.Feld_loeschenClick(Sender: TObject);
begin
  Edit2.Clear;
end;

{--- gibt das unsortierte Feld von Zufallszahlen aus -----}
procedure TForm1.Ausgabe_unsortClick(Sender: TObject);
var
  i: integer;
  s1,s2: string;
begin
  s1 := '';
  for i := 1 to 10 do
  begin
    s2 := IntToStr(f_original[i]);
    s1 := s1 + s2 + ' ';
  end;
  Edit1.Text := s1;
end;

{-------- Prozedur zum Vertauschen zweier Zahlen ----------}
procedure tausche(var a,b: integer);
var
  h: integer;
begin
  h := a;
  a := b;
  b := h;
end;

{------------- Ausgabe des sortierten Feldes --------------}
procedure ausgabe(f_kopie: feld);
var
  i : integer;
 s1,s2: string;
begin
  s1 := '';
  for i := 1 to 10 do
  begin
    s2 := IntToStr(f_kopie[i]);
    s1 := s1 + s2 + ' ';
  end;
  Form1.Edit2.Text := s1;
end;

{--- initialisiert ein vorsortiertes Feld von 10 Zahlen ---}
procedure TForm1.Init1Click(Sender: TObject);
var
  i: integer;
begin
  for i := 1 to 10 do f_original[i] := i;
end;

{-- initialisiert ein absteigend sortiertes Feld von Zahlen --}
procedure TForm1.Init2Click(Sender: TObject);
var
  i,j: integer;
begin
  j := 10;
  for i := 1 to 10 do
  begin
    f_original[i] := j;
    dec(j);
  end;  
end;

{-------------- Sortieren durch Auswaehlen ----------------}
procedure TForm1.SelectionSortClick(Sender: TObject);
var
  i,j,tausch, vergleich: integer;
begin
  for i := 1 to 10 do f_ausw[i] := f_original[i];
  tausch := 0;
  vergleich := 0;
  for i := 1 to 9 do
  begin
    for j := i+1 to 10 do
    begin
      inc(vergleich);
      if f_ausw[j] < f_ausw[i] then
      begin
        inc(tausch);
        tausche(f_ausw[j],f_ausw[i]);
      end;  
    end;
  end;
  ausgabe(f_ausw);
  Edit3.Text := IntToStr(tausch);
  Edit6.Text := IntToStr(vergleich); 
end;

{----------- Sortieren durch Einfuegen --------------------}
procedure TForm1.InsertionSortClick(Sender: TObject);
var
  i,j,merke,vergleich: integer;
begin
  vergleich := 0;
  for i := 1 to 10 do f_einfg[i] := f_original[i];
  for i:=2 to 10 do
  begin
    j :=i;
    merke :=f_einfg[i];	//Feldinhalt der Position i merken
    While (j>1) and (f_einfg[j-1]>merke) do
    {Vergleichen des gemerkten Elementes mit den vorherigen
    Elementen - Solange Feldindex groesser 1 und Feldinhalte
    groesser als gemerkter Feldinhalt}
    begin
      inc(vergleich);
      f_einfg[j]:=f_einfg[j-1];   // Nach rechts Ruecken der Feldinhalte
      j:=j-1;   // Eine Position weiter nach links gehen
    end;
    f_einfg[j]:= merke;  // Inhalt der Position i auf Position j einfuegen
    ausgabe(f_einfg);
    Edit7.Text := IntToStr(vergleich);
  end;
end;

{ -------------- Bubblesort -------------------------------}

procedure TForm1.BubblesortClick(Sender: TObject);
var
  ende, i, tausch, vergleich: integer;
  boTausch: boolean;
begin
  tausch := 0;
  vergleich := 0;
  for i := 1 to 10 do f_bubble[i] := f_original[i];
  ende := 9;
  repeat
  boTausch := false;
  for i := 1 to ende do
  begin
    inc(vergleich);
    if f_bubble[i] > f_bubble[i+1] then
    begin
      inc(tausch);
      tausche(f_bubble[i+1],f_bubble[i]);
      boTausch := true;
    end;
  end;
  dec(ende);
  until (ende = 0) or (not boTausch);
  ausgabe(f_bubble);
  Edit5.Text := IntToStr(tausch);
  Edit8.Text := IntToStr(vergleich);
end;

end.
